package contextualbreakpoints.ui.actions;

import java.util.List;

import org.eclipse.jface.action.Action;

import contextualbreakpoints.breakpoints.IJavaContextualBreakpoint;
import contextualbreakpoints.pointcuts.AndPointcut;
import contextualbreakpoints.pointcuts.NotPointcut;
import contextualbreakpoints.pointcuts.OrPointcut;
import contextualbreakpoints.pointcuts.Pointcut;

public abstract class BreakpointConditionAction extends Action {

	protected IJavaContextualBreakpoint breakpoint;
	
	protected BreakpointConditionAction(IJavaContextualBreakpoint breakpoint) {
		this.breakpoint = breakpoint;
	}
	
	protected OrPointcut getBreakpointExceptCondition() {
		Pointcut cond = breakpoint.getContextCondition();
		
		OrPointcut exceptCond = null;
		if (cond instanceof AndPointcut) {
			AndPointcut andCond = (AndPointcut)cond;
			List conds = andCond.getPointcuts();
			if (conds.size() == 2) {
				if (conds.get(0) instanceof NotPointcut) {
					NotPointcut notCond = (NotPointcut)conds.get(0);
					if (notCond.getPointcut() instanceof OrPointcut) {
						exceptCond = (OrPointcut)notCond.getPointcut();
					}
				}
			}
		}
		return exceptCond;
	}
	
	protected AndPointcut getBreakpointOnlyCondition() {
		Pointcut cond = breakpoint.getContextCondition();
		
		AndPointcut onlyCond = null;
		if (cond instanceof AndPointcut) {
			AndPointcut andCond = (AndPointcut)cond;
			List conds = andCond.getPointcuts();
			if (conds.size() == 2) {
				if (conds.get(1) instanceof AndPointcut) {
					onlyCond = (AndPointcut)conds.get(1);
				}
			}
		}
		return onlyCond;
	}
}
