package contextualbreakpoints.ui.actions;

import java.util.Iterator;
import java.util.List;

import org.eclipse.jface.action.Separator;
import org.eclipse.jface.text.source.IVerticalRulerInfo;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.ui.texteditor.ITextEditor;

import contextualbreakpoint.ui.utils.FriendlyNames;
import contextualbreakpoints.breakpoints.IJavaContextualLineBreakpoint;
import contextualbreakpoints.contextlogic.DebuggerContext;

public class ExceptAfterContextMenuAction extends BreakpointConditionContextMenuAction {
	
	public ExceptAfterContextMenuAction(ITextEditor editor, IVerticalRulerInfo rulerInfo) {
		super(editor, rulerInfo);
	}
	
	public ExceptAfterContextMenuAction() {
		super(null, null);
	}

	protected void fillMenu(Menu menu) {
		int count = 0;
		DebuggerContext context = DebuggerContext.getInstance();
		List reachedBreakpoints = context.getHasSuspendedBreakpoints();
		for (Iterator i = reachedBreakpoints.iterator(); i.hasNext();) {
			Object obj = i.next();
			if (obj instanceof IJavaContextualLineBreakpoint) {
				IJavaContextualLineBreakpoint bp = (IJavaContextualLineBreakpoint)obj;
				ExceptAfterBreakpointRulerAction action = new ExceptAfterBreakpointRulerAction(editor, rulerInfo, FriendlyNames.getFriendlyName(bp), bp);
				addActionToMenu(menu, action);
				count++;
			}
		}
//		// the notReached breakpoints (positive context)
//		List notReachedBreakpoints = context.getNotHasSuspendedBreakpoints();
//		if ((notReachedBreakpoints.size() > 0) && (count > 0)) {
//			Separator sep = new Separator();
//			sep.fill(menu, count);
//		}
//		for (Iterator i = notReachedBreakpoints.iterator(); i.hasNext();) {
//			Object obj = i.next();
//			if (obj instanceof IJavaContextualLineBreakpoint) {
//				IJavaContextualLineBreakpoint bp = (IJavaContextualLineBreakpoint)obj;
//				ExceptAfterBreakpointRulerAction action = new ExceptAfterBreakpointRulerAction(editor, rulerInfo, FriendlyNames.getFriendlyName(bp), bp);
//				addActionToMenu(menu, action);
//				count++;
//			}
//		}
	}
	
	
}
