package contextualbreakpoints.ui.actions;

import contextualbreakpoints.breakpoints.IJavaContextualBreakpoint;
import contextualbreakpoints.breakpoints.IJavaContextualLineBreakpoint;
import contextualbreakpoints.pointcuts.BeforePointcut;
import contextualbreakpoints.pointcuts.LineExecutionPointcut;
import contextualbreakpoints.pointcuts.OrPointcut;

public class ExceptBeforeAction extends BreakpointConditionAction {
	IJavaContextualLineBreakpoint before;
	
	public ExceptBeforeAction(IJavaContextualBreakpoint breakpoint, 
			IJavaContextualLineBreakpoint before) {
		super(breakpoint);
		this.before = before;
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.jface.action.IAction#run()
	 */
	public void run() {
		OrPointcut exceptCond = getBreakpointExceptCondition();
		
		LineExecutionPointcut lep = new LineExecutionPointcut(before);
		
		BeforePointcut beforeCond = new BeforePointcut();
		beforeCond.setPointcut(lep);
		exceptCond.addPointcut(beforeCond);
	}
}
