package contextualbreakpoints.ui.actions;

import java.util.Iterator;
import java.util.List;

import org.eclipse.jface.action.Separator;
import org.eclipse.jface.text.source.IVerticalRulerInfo;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.ui.texteditor.ITextEditor;

import contextualbreakpoint.ui.utils.FriendlyNames;
import contextualbreakpoints.breakpoints.IJavaContextualLineBreakpoint;
import contextualbreakpoints.contextlogic.DebuggerContext;

public class ExceptBeforeContextMenuAction extends BreakpointConditionContextMenuAction {

	public ExceptBeforeContextMenuAction(ITextEditor editor, IVerticalRulerInfo rulerInfo) {
		super(editor, rulerInfo);
	}

	protected void fillMenu(Menu menu) {
		int count = 0;
		// the unreached breakpoints (negative context)
		DebuggerContext context = DebuggerContext.getInstance();
		List notReachedBreakpoints = context.getNotHasSuspendedBreakpoints();
		for (Iterator i = notReachedBreakpoints.iterator(); i.hasNext();) {
			Object obj = i.next();
			if (obj instanceof IJavaContextualLineBreakpoint) {
				IJavaContextualLineBreakpoint bp = (IJavaContextualLineBreakpoint)obj;
				ExceptBeforeBreakpointRulerAction action = new ExceptBeforeBreakpointRulerAction(editor, rulerInfo, FriendlyNames.getFriendlyName(bp), bp);
				addActionToMenu(menu, action);
				count++;
			}
		}
//		// the reached breakpoints (positive context)
//		List reachedBreakpoints = context.getHasSuspendedBreakpoints();
//		if ((reachedBreakpoints.size() > 0) && (count > 0)) {
//			Separator sep = new Separator();
//			sep.fill(menu, count);
//		}
//		for (Iterator i = reachedBreakpoints.iterator(); i.hasNext();) {
//			Object obj = i.next();
//			if (obj instanceof IJavaContextualLineBreakpoint) {
//				IJavaContextualLineBreakpoint bp = (IJavaContextualLineBreakpoint)obj;
//				ExceptBeforeBreakpointRulerAction action = new ExceptBeforeBreakpointRulerAction(editor, rulerInfo, FriendlyNames.getFriendlyName(bp), bp);
//				addActionToMenu(menu, action);
//				count++;
//			}
//		}
	}

}
