package contextualbreakpoints.ui.actions;

import contextualbreakpoints.breakpoints.IJavaContextualBreakpoint;
import contextualbreakpoints.contextlogic.MethodKey;
import contextualbreakpoints.pointcuts.CFlowPointcut;
import contextualbreakpoints.pointcuts.OrPointcut;
import contextualbreakpoints.pointcuts.MethodExecutionPointcut;

public class ExceptCFlowAction extends BreakpointConditionAction {
	MethodKey methKey;
	
	public ExceptCFlowAction(IJavaContextualBreakpoint breakpoint, 
			MethodKey methKey) {
		super(breakpoint);
		this.methKey = methKey;
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.jface.action.IAction#run()
	 */
	public void run() {
		OrPointcut exceptCond = getBreakpointExceptCondition();
		CFlowPointcut cflowCond = new CFlowPointcut();
		MethodExecutionPointcut mep = new MethodExecutionPointcut(methKey);
		cflowCond.setPointcut(mep);
		exceptCond.addPointcut(cflowCond);
	}
}
