package contextualbreakpoints.ui.actions;

import java.util.Iterator;
import java.util.List;

import org.eclipse.jface.action.Separator;
import org.eclipse.jface.text.source.IVerticalRulerInfo;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.ui.texteditor.ITextEditor;

import contextualbreakpoint.ui.utils.FriendlyNames;
import contextualbreakpoints.contextlogic.DebuggerContext;
import contextualbreakpoints.contextlogic.MethodKey;

public class ExceptCFlowContextMenuAction extends BreakpointConditionContextMenuAction {

	public ExceptCFlowContextMenuAction(ITextEditor editor, IVerticalRulerInfo rulerInfo) {
		super(editor, rulerInfo);
	}

	protected void fillMenu(Menu menu) {
		int count = 0;
		DebuggerContext context = DebuggerContext.getInstance();
		List callStack = context.getCallStack();
		Iterator ii = callStack.iterator();
		if (ii.hasNext()) {
			ii.next(); // skip very top of the stack
		}
		while (ii.hasNext()) {
			Object obj = ii.next();
			if (obj instanceof MethodKey) {
				MethodKey mk = (MethodKey)obj;
				ExceptCFlowBreakpointRulerAction action = new ExceptCFlowBreakpointRulerAction(editor, rulerInfo, FriendlyNames.getFriendlyName(mk), mk);
				addActionToMenu(menu, action);
				count++;
			}
		}
//		// the method breakpoint ones too 	
//		List userMethods = context.getMethodBreakpointMethods();
//		if ((userMethods.size() > 0) && (count > 0)) {
//			Separator sep = new Separator();
//			sep.fill(menu, count);
//		}
//		for (Iterator i = userMethods.iterator(); i.hasNext();) {
//			Object obj = i.next();
//			if (obj instanceof MethodKey) {
//				MethodKey mk = (MethodKey)obj;
//				ExceptCFlowBreakpointRulerAction action = new ExceptCFlowBreakpointRulerAction(editor, rulerInfo, FriendlyNames.getFriendlyName(mk), mk);
//				addActionToMenu(menu, action);
//			}
//		}
	}
	
}
