package contextualbreakpoints.ui.actions;

import contextualbreakpoints.breakpoints.IJavaContextualBreakpoint;
import contextualbreakpoints.breakpoints.IJavaContextualLineBreakpoint;
import contextualbreakpoints.pointcuts.AfterPointcut;
import contextualbreakpoints.pointcuts.AndPointcut;
import contextualbreakpoints.pointcuts.LineExecutionPointcut;
import contextualbreakpoints.pointcuts.OrPointcut;

public class OnlyAfterAction extends BreakpointConditionAction {
	
	IJavaContextualLineBreakpoint after;
	
	public OnlyAfterAction(IJavaContextualBreakpoint breakpoint, 
			IJavaContextualLineBreakpoint after) {
		super(breakpoint);
		this.after = after;
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.jface.action.IAction#run()
	 */
	public void run() {
		AndPointcut onlyCond = getBreakpointOnlyCondition();
		
		LineExecutionPointcut lep = new LineExecutionPointcut(after);
		
		AfterPointcut afterCond = new AfterPointcut();
		afterCond.setPointcut(lep);
		onlyCond.addPointcut(afterCond);
	}
	
}
