package contextualbreakpoints.ui.actions;

import org.eclipse.jface.action.IAction;
import org.eclipse.jface.text.source.IVerticalRulerInfo;
import org.eclipse.ui.IEditorPart;
import org.eclipse.ui.texteditor.AbstractRulerActionDelegate;
import org.eclipse.ui.texteditor.ITextEditor;

public class OnlyAfterContextMenuActionDelegate extends AbstractRulerActionDelegate {
	
	private OnlyAfterContextMenuAction delegateAction;
	
	/**
	 * @see AbstractRulerActionDelegate#createAction(ITextEditor, IVerticalRulerInfo)
	 */
	protected IAction createAction(ITextEditor editor, IVerticalRulerInfo rulerInfo) {
		delegateAction = new OnlyAfterContextMenuAction(editor, rulerInfo);
	    delegateAction.setText("Only Suspend After Reaching Line"); //$NON-NLS-1$
	    return delegateAction;
	}

	public void setActiveEditor(IAction action, IEditorPart targetEditor) {
		super.setActiveEditor(action, targetEditor);
		action.setMenuCreator(delegateAction);
	}
}
