package contextualbreakpoints.ui.actions;

import contextualbreakpoints.breakpoints.IJavaContextualBreakpoint;
import contextualbreakpoints.breakpoints.IJavaContextualLineBreakpoint;
import contextualbreakpoints.pointcuts.AndPointcut;
import contextualbreakpoints.pointcuts.BeforePointcut;
import contextualbreakpoints.pointcuts.LineExecutionPointcut;
import contextualbreakpoints.pointcuts.OrPointcut;

public class OnlyBeforeAction extends BreakpointConditionAction {
	IJavaContextualLineBreakpoint before;
	
	public OnlyBeforeAction(IJavaContextualBreakpoint breakpoint, 
			IJavaContextualLineBreakpoint before) {
		super(breakpoint);
		this.before = before;
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.jface.action.IAction#run()
	 */
	public void run() {
		AndPointcut onlyCond = getBreakpointOnlyCondition();
		
		LineExecutionPointcut lep = new LineExecutionPointcut(before);
		
		BeforePointcut beforeCond = new BeforePointcut();
		beforeCond.setPointcut(lep);
		onlyCond.addPointcut(beforeCond);
	}
}
