package contextualbreakpoints.ui.actions;

import java.util.Iterator;
import java.util.List;

import org.eclipse.jdt.debug.core.IJavaBreakpoint;
import org.eclipse.jface.action.Separator;
import org.eclipse.jface.text.source.IVerticalRulerInfo;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.ui.texteditor.ITextEditor;

import contextualbreakpoint.ui.utils.FriendlyNames;
import contextualbreakpoints.breakpoints.IJavaContextualBreakpoint;
import contextualbreakpoints.breakpoints.IJavaContextualLineBreakpoint;
import contextualbreakpoints.contextlogic.DebuggerContext;

public class OnlyBeforeContextMenuAction extends BreakpointConditionContextMenuAction {

	public OnlyBeforeContextMenuAction(ITextEditor editor, IVerticalRulerInfo rulerInfo) {
		super(editor, rulerInfo);
	}

	protected void fillMenu(Menu menu) {

		IJavaBreakpoint jbp = DebuggerContext.getInstance().getBreakpointByLine(
				rulerInfo.getLineOfLastMouseButtonActivity());
		if (jbp != null && jbp instanceof IJavaContextualBreakpoint) {
			IJavaContextualBreakpoint targbp = (IJavaContextualBreakpoint)jbp;
			List reachedBreakpoints = targbp.getSavedBeforeBreakpoints();
			for (Iterator i = reachedBreakpoints.iterator(); i.hasNext();) {
				Object obj = i.next();
				if (obj instanceof IJavaContextualLineBreakpoint) {
					IJavaContextualLineBreakpoint bp = (IJavaContextualLineBreakpoint)obj;
					OnlyBeforeBreakpointRulerAction action = new OnlyBeforeBreakpointRulerAction(editor, rulerInfo, FriendlyNames.getFriendlyName(bp), bp);
					addActionToMenu(menu, action);
				}
			}
		}
	}

}
