package contextualbreakpoints.ui.actions;

import contextualbreakpoints.breakpoints.IJavaContextualBreakpoint;
import contextualbreakpoints.contextlogic.MethodKey;
import contextualbreakpoints.pointcuts.AndPointcut;
import contextualbreakpoints.pointcuts.CFlowPointcut;
import contextualbreakpoints.pointcuts.MethodExecutionPointcut;

public class OnlyCFlowAction extends BreakpointConditionAction {
	MethodKey methKey;
	
	public OnlyCFlowAction(IJavaContextualBreakpoint breakpoint, 
			MethodKey methKey) {
		super(breakpoint);
		this.methKey = methKey;
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.jface.action.IAction#run()
	 */
	public void run() {
		AndPointcut onlyCond = getBreakpointOnlyCondition();
		CFlowPointcut cflowCond = new CFlowPointcut();
		MethodExecutionPointcut mep = new MethodExecutionPointcut(methKey);
		cflowCond.setPointcut(mep);
		onlyCond.addPointcut(cflowCond);
	}
}
