package contextualbreakpoints.ui.actions;

import java.util.Iterator;
import java.util.List;

import org.eclipse.core.resources.IMarker;
import org.eclipse.core.runtime.CoreException;
import org.eclipse.debug.core.DebugPlugin;
import org.eclipse.debug.core.model.IBreakpoint;
import org.eclipse.jdt.debug.core.IJavaBreakpoint;
import org.eclipse.jdt.debug.core.IJavaLineBreakpoint;
import org.eclipse.jdt.debug.core.IJavaMethodBreakpoint;
import org.eclipse.jface.action.Separator;
import org.eclipse.jface.text.source.IVerticalRulerInfo;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.ui.texteditor.ITextEditor;

import contextualbreakpoint.ui.utils.FriendlyNames;
import contextualbreakpoints.breakpoints.IJavaContextualBreakpoint;
import contextualbreakpoints.contextlogic.DebuggerContext;
import contextualbreakpoints.contextlogic.MethodKey;

public class OnlyCFlowContextMenuAction extends BreakpointConditionContextMenuAction {

	public OnlyCFlowContextMenuAction(ITextEditor editor, IVerticalRulerInfo rulerInfo) {
		super(editor, rulerInfo);
	}

	protected void fillMenu(Menu menu) {
		
		//	the original call stack (positive context) when bp was first reached
		IJavaBreakpoint jbp = DebuggerContext.getInstance().getBreakpointByLine(
				rulerInfo.getLineOfLastMouseButtonActivity());
		if (jbp != null && jbp instanceof IJavaContextualBreakpoint) {
			IJavaContextualBreakpoint bp = (IJavaContextualBreakpoint)jbp;
			List methKeys = bp.getSavedCallStack();
			// skip top of stack
			Iterator i = methKeys.iterator();
			if (i.hasNext()){
				i.next();
			}
			while (i.hasNext()) {
				Object obj = i.next();
				if (obj instanceof MethodKey) {
					MethodKey mk = (MethodKey)obj;
					OnlyCFlowBreakpointRulerAction action = new OnlyCFlowBreakpointRulerAction(
							editor, rulerInfo, FriendlyNames.getFriendlyName(mk), mk);
					addActionToMenu(menu, action);
				}
			}
		}

	}
}
