package contextualbreakpoints.ui.actions;

import java.util.Iterator;
import java.util.List;

import contextualbreakpoints.breakpoints.IJavaContextualBreakpoint;
import contextualbreakpoints.contextlogic.DebuggerContext;
import contextualbreakpoints.contextlogic.IClippyDialog;
import contextualbreakpoints.pointcuts.Pointcut;

public class SuggestOriginalAction extends BreakpointConditionAction {

	public SuggestOriginalAction(IJavaContextualBreakpoint bp) {
		super(bp);
	}

	/* (non-Javadoc)
	 * @see org.eclipse.jface.action.IAction#run()
	 */
	public void run() {
		List savedContext = breakpoint.getSavedContext();
		Pointcut[] pcs = new Pointcut[savedContext.size()];
		int index = 0;
		for (Iterator i = savedContext.iterator(); i.hasNext();) {
			Pointcut pc = (Pointcut)i.next();
			pcs[index] = pc;
			index++;
		}
		DebuggerContext.getInstance().getClippy().open(breakpoint, pcs, IClippyDialog.BP_RESTRICT_ORIG);
	}
	
}
