package contextualbreakpoints.ui.listeners;

import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.SelectionListener;

import contextualbreakpoints.breakpoints.IJavaContextualBreakpoint;
import contextualbreakpoints.contextlogic.DefaultsLogic;
import contextualbreakpoints.ui.widgets.ContextDialog;

public class ContextResetListener implements SelectionListener {
	
	private IJavaContextualBreakpoint breakpoint; // breakpoint to pass to dialog;
	private ContextDialog dialog;
	
	public void widgetSelected(SelectionEvent e) {
		// add to the breakpoint's context
		if (dialog != null && breakpoint != null) {
			breakpoint.setContextCondition(DefaultsLogic.getDefaultResidual());
			dialog.updateBreakpointContextExpression(breakpoint);
		}
	}

	public void widgetDefaultSelected(SelectionEvent e) {
	}

	/**
	 * @return Returns the breakpoint.
	 */
	public IJavaContextualBreakpoint getBreakpoint() {
		return breakpoint;
	}

	/**
	 * @param breakpoint The breakpoint to set.
	 */
	public void setBreakpoint(IJavaContextualBreakpoint breakpoint) {
		this.breakpoint = breakpoint;
	}

	/**
	 * @return Returns the dialog.
	 */
	public ContextDialog getDialog() {
		return dialog;
	}

	/**
	 * @param dialog The dialog to set.
	 */
	public void setDialog(ContextDialog dialog) {
		this.dialog = dialog;
	}

}