package contextualbreakpoints.ui.management;


import contextualbreakpoints.contextlogic.DebuggerContext;
import contextualbreakpoints.ui.widgets.ClippyDialog;

public class ContextualBreakpointsUIManager {
	private static ContextualBreakpointsUIManager instance;
	
	private ContextualBreakpointsUIManager() {
		
	}
	
	/**
	 * @return the singleton instance of the manager
	 */
	public static ContextualBreakpointsUIManager getInstance() {
		if (instance == null) {
			instance = new ContextualBreakpointsUIManager();
		}
		return instance;
	}
	
	/**
	 * This function prepares the contextual breakpoints classes for first use
	 * Called by JDIDebugUIPlugin.startup()
	 */
	public void startup() {
		
		// give the DebugContext an instance of the clippy dialog
		DebuggerContext.getInstance().setClippy(ClippyDialog.getCopy());
	
		// insert other startup procedures here
	}
}
