package triggerpointui.views;

import java.util.ArrayList;
import java.util.HashSet;

import org.eclipse.debug.core.DebugPlugin;
import org.eclipse.debug.core.model.IBreakpoint;
import org.eclipse.jface.viewers.ITreeContentProvider;
import org.eclipse.jface.viewers.Viewer;

import contextualbreakpoints.breakpoints.JavaContextualLineBreakpoint;




/*
 * The content provider class is responsible for
 * providing objects to the view. It can wrap
 * existing objects in adapters or simply return
 * objects as-is. These objects may be sensitive
 * to the current input of the view, or ignore
 * it and always show the same content 
 * (like Task List, for example).
 */

/**
 * @author Rick
 *
 */
public class TriggerPointHierarchyViewContentProvider implements ITreeContentProvider {
	public void inputChanged(Viewer v, Object oldInput, Object newInput) {
	}
	public void dispose() {
	}
	public Object[] getElements(Object parent) {
//		return new String[] { "Root1", "Root2" };
		IBreakpoint[] bps = DebugPlugin.getDefault().getBreakpointManager().getBreakpoints();
		IBreakpoint[] rootbps;
		
		// the breakpoints as a set
		HashSet totalBreakpoints = new HashSet();
		for (int i = 0; i < bps.length; i++) {
			if (bps[i] instanceof JavaContextualLineBreakpoint) {
				totalBreakpoints.add(bps[i]);
			}
		}
		
		// remove breakpoints that are triggered by any breakpoint
		for (int i = 0; i < bps.length; i++) {
			Object[] toKill = getChildren(bps[i]);
			if (toKill != null) {
				for (int j = 0; j < toKill.length; j++) {
					System.out.println("Trigger Hierarchy View - removing breakpoint "+toKill[j]);
					totalBreakpoints.remove(toKill[j]);
				}
			}
		}
		return totalBreakpoints.toArray();
	}
	public Object[] getChildren(Object parentElement) {
//		if (parentElement instanceof String) {
//		String parent = (String)parentElement;
//		if (parent.equals("Root1")) {
//		return new String[] {"R1Level1a", "R1Level1b", "R1Level1c"};
//		} else if (parent.equals("Root2")) {
//		return new String[] {"R2Level1a", "R2Level1b"};
//		} else if (parent.equals("R1Level1a")) {
//		return new String[] {"R1Level2a", "R1Level2b"};
//		} else if (parent.equals("R2Level1b")) {
//		return new String[] {"R2Level2a"};
//		}
//		}
		
//		if (parentElement instanceof JavaContextualLineBreakpoint) {
//			JavaContextualLineBreakpoint bp = 
//				(JavaContextualLineBreakpoint)parentElement;
//			Object[] deps = bp.getDependents().toArray();
//			if (deps == null || deps.length == 0) {
//				return null;
//			}
//			// remove dependents that aren't registered anymore
//			ArrayList depsList = new ArrayList();
//			for (int i = 0; i < deps.length; i++) {
//				if (DebugPlugin.getDefault().getBreakpointManager().isRegistered(
//						(IBreakpoint)deps[i])) {
//					depsList.add(deps[i]);
//				}
//			}
//			return depsList.toArray();
//		}
		return null;
	}
	public Object getParent(Object element) {
//		if (element instanceof String) {
//		String elem = (String)element;
//		if (elem.equals("R1Level1a") ||
//		elem.equals("R1Level1b") ||
//		elem.equals("R1Level1c")) {
//		return "Root1";
//		}
//		}
		return null;
	}
	public boolean hasChildren(Object element) {
		return (getChildren(element) != null);
	}
}
