package contextualbreakpoints.contextlogic;

import java.util.HashMap;
import java.util.List;

import org.eclipse.jdt.internal.debug.core.IJDIEventListener;
import org.eclipse.jdt.internal.debug.core.model.JDIDebugTarget;

import com.sun.jdi.request.EventRequest;

import contextualbreakpoints.breakpoints.IJavaContextualLineBreakpoint;

public class LineEventCache {
	private HashMap cache;
	
	public LineEventCache () {
		cache = new HashMap();
	}
	
	public void addEntry(IJDIEventListener listener, EventRequest request, JDIDebugTarget target) {
		LineEventCacheItem item = (LineEventCacheItem)cache.get(listener);
		if (item == null) {
			item = new LineEventCacheItem();
			cache.put(listener, item);
		}
		item.addItem(request, target);
	}
	
	public boolean hasRequest(IJDIEventListener listener, EventRequest request) {
		LineEventCacheItem item = (LineEventCacheItem)cache.get(listener);
		if (item == null) {
			return false;
		}
		return item.hasRequest(request);
	}

	public List getEventRequests(IJavaContextualLineBreakpoint bp) {
		LineEventCacheItem item = (LineEventCacheItem)cache.get(bp);
		if (item == null) {
			return null;
		}
		return item.getRequests();
	}
	
	public boolean hasTarget(IJDIEventListener listener, JDIDebugTarget target) {
		LineEventCacheItem item = (LineEventCacheItem)cache.get(listener);
		if (item == null) {
			return false;
		}
		return item.hasTarget(target);
	}
}
