package contextualbreakpoints.contextlogic;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.eclipse.jdt.internal.debug.core.model.JDIDebugTarget;

import com.sun.jdi.request.EventRequest;

public class LineEventCacheItem {
	
	private ArrayList pairs;
	
	public LineEventCacheItem() {
		pairs = new ArrayList();
	}
	
	public void addItem(EventRequest request, JDIDebugTarget target) {
		pairs.add(new Pair(request, target));
	}
	
	public boolean hasRequest(EventRequest request) {
		for (Iterator i = pairs.iterator(); i.hasNext();) {
			Pair p = (Pair)i.next();
			if (p.getRequest().equals(request)) {
				return true;
			}
		}
		return false;
	}
	
	public List getRequests() {
		List requests = new ArrayList();
		for (Iterator i = pairs.iterator(); i.hasNext();) {
			Pair p = (Pair)i.next();
			requests.add(p.getRequest());
		}
		return requests;
	}
	
	public boolean hasTarget(JDIDebugTarget target) {
		for (Iterator i = pairs.iterator(); i.hasNext();) {
			Pair p = (Pair)i.next();
			if (p.getTarget().equals(target)) {
				return true;
			}
		}
		return false;
	}
}
