package contextualbreakpoints.pointcuts;

import org.eclipse.jdt.internal.debug.core.model.JDIThread;



/**
 * @author Rick
 * 
 * True after child pc
 *
 */
public class AfterPointcut implements Pointcut {

	private Pointcut pointcut;
	
	/* (non-Javadoc)
	 * @see conditions.Condition#isTrue()
	 */
	public boolean isMatch(JDIThread thread) {
		// FOR NOW, only know how to deal with LineExecution child
		if (pointcut instanceof LineExecutionPointcut) {
			LineExecutionPointcut lepc = (LineExecutionPointcut)pointcut;
			return lepc.hasBeenReached();
		}
		return false;
	}


	/**
	 * @return Returns the pointcut.
	 */
	public Pointcut getPointcut() {
		return pointcut;
	}


	/**
	 * @param pointcut The pointcut to set.
	 */
	public void setPointcut(Pointcut pointcut) {
		this.pointcut = pointcut;
	}


	public Pointcut copy() {
		AfterPointcut copy = new AfterPointcut();
		copy.setPointcut(getPointcut().copy());
		return copy;
	}

}
