package contextualbreakpoints.pointcuts;

import java.util.ArrayList;
import java.util.Iterator;

import org.eclipse.jdt.internal.debug.core.model.JDIThread;

/**
 * @author Rick
 *
 */
public class AndPointcut implements Pointcut {

	private ArrayList pointcuts;
	
	public AndPointcut() {
		pointcuts = new ArrayList();
	}
	
	public boolean isMatch(JDIThread thread) {
		// return true if all pointcuts true
		for (int i = 0; i < pointcuts.size(); i++) {
			Pointcut cond = (Pointcut)pointcuts.get(i);
			if (!cond.isMatch(thread)) {
				return false;
			}
		}
		return true;
	}
	
	/**
	 * @return Returns the Pointcuts.
	 */
	public ArrayList getPointcuts() {
		return pointcuts;
	}

	/**
	 * @param conditions The pointcuts to set.
	 */
	public void setPointcuts(ArrayList pointcuts) {
		this.pointcuts = pointcuts;
	}
	
	/**
	 * @param cond the condition to add
	 */
	public void addPointcut(Pointcut pc) {
		pointcuts.add(pc);
	}
	
	/**
	 * @param cond
	 * @return true if operation successful
	 */
	public boolean removePointcut(Pointcut pc) {
		return pointcuts.remove(pc);
	}

	public Pointcut copy() {
		AndPointcut copy = new AndPointcut();
		for (Iterator i = getPointcuts().iterator(); i.hasNext();) {
			Pointcut pc = (Pointcut)i.next();
			copy.addPointcut(pc.copy());
		}
		return copy;
	}

}
