package contextualbreakpoints.pointcuts;

import org.eclipse.jdt.internal.debug.core.model.JDIThread;

import com.sun.jdi.IncompatibleThreadStateException;
import com.sun.jdi.Method;
import com.sun.jdi.StackFrame;
import com.sun.jdi.ThreadReference;

import contextualbreakpoints.contextlogic.DebuggerContext;
import contextualbreakpoints.contextlogic.MethodKey;

public class MethodExecutionPointcut implements Pointcut {

	private MethodKey methKey;
	
	public MethodExecutionPointcut(MethodKey methKey) {
		this.methKey = methKey;
	}
	
	/* (non-Javadoc)
	 * @see conditions.Condition#isTrue()
	 */
	public boolean isMatch(JDIThread thread) {
		
		// get method itself
		Method method = DebuggerContext.getInstance().getMethodByName(methKey);
		
		ThreadReference  uThread = thread.getUnderlyingThread();
		try {
			int top = uThread.frameCount() - 1;
			StackFrame fr = uThread.frame(top);
			if (fr.location().method().equals(method)) {
				return true;
			}
		} catch (IncompatibleThreadStateException e) {
			e.printStackTrace();
		}
		return false;
	}
	
	public void setMethodKey(MethodKey methKey) {
		this.methKey = methKey;
	}
	
	public MethodKey getMethodKey() {
		return methKey;
	}

	public Pointcut copy() {
		MethodExecutionPointcut copy = new MethodExecutionPointcut(getMethodKey());
		return copy;
	}
}
