package contextualbreakpoints.pointcuts;

import org.eclipse.jdt.internal.debug.core.model.JDIThread;

public class NotPointcut implements Pointcut {

	private Pointcut pointcut;
	
	public NotPointcut() {
		pointcut = new NullPointcut();
	}
	
	/* (non-Javadoc)
	 * @see conditions.Condition#isTrue()
	 */
	public boolean isMatch(JDIThread thread) {
		// return opposite of what the condition returns
		return !pointcut.isMatch(thread);
	}

	/**
	 * @return Returns the pointcut.
	 */
	public Pointcut getPointcut() {
		return pointcut;
	}

	/**
	 * @param pointcut The pointcut to set.
	 */
	public void setPointcut(Pointcut pointcut) {
		this.pointcut = pointcut;
	}

	public Pointcut copy() {
		NotPointcut copy = new NotPointcut();
		copy.setPointcut(getPointcut().copy());
		return copy;
	}
}
