package contextualbreakpoints.pointcuts;

import java.util.ArrayList;
import java.util.Iterator;

import org.eclipse.jdt.internal.debug.core.model.JDIThread;

public class OrPointcut implements Pointcut {

	
	private ArrayList pointcuts;
	
	public OrPointcut() {
		pointcuts = new ArrayList();
	}
	
	/* (non-Javadoc)
	 * @see conditions.Condition#isTrue()
	 */
	public boolean isMatch(JDIThread thread) {
		
		// return true if at least one condition is true
		for (int i = 0; i < pointcuts.size(); i++) {
			Pointcut cond = (Pointcut)pointcuts.get(i);
			if (cond.isMatch(thread)) {
				return true;
			}
		}
		return false;
	}

	
	/**
	 * @param cond the pointcut to add
	 */
	public void addPointcut(Pointcut pc) {
		pointcuts.add(pc);
	}
	
	/**
	 * @param pc
	 * @return true if operation successful
	 */
	public boolean removePointcut(Pointcut pc) {
		return pointcuts.remove(pc);
	}


	/**
	 * @return Returns the pointcuts.
	 */
	public ArrayList getPointcuts() {
		return pointcuts;
	}

	/**
	 * @param pointcuts The pointcuts to set.
	 */
	public void setPointcuts(ArrayList pointcuts) {
		this.pointcuts = pointcuts;
	}
	
	public Pointcut copy() {
		OrPointcut copy = new OrPointcut();
		for (Iterator i = getPointcuts().iterator(); i.hasNext();) {
			Pointcut pc = (Pointcut)i.next();
			copy.addPointcut(pc.copy());
		}
		return copy;
	}
}
