package contextualbreakpoints.pointcuts;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Set;

public class PointcutManager {
	
	private HashMap pcs;
	private HashSet lepPCs;
	private static PointcutManager instance;
	
	public static PointcutManager getInstance() {
		if (instance == null) {
			instance = new PointcutManager();
		}
		return instance;
	}
	
	private PointcutManager() {
		instance = null;
		lepPCs = new HashSet();
		pcs = new HashMap();
	}
	
	public void addLineExecutionPointcut(LineExecutionPointcut lep) {
		lepPCs.add(lep);
	}
	
	public void removeLineExecutionPointcut(LineExecutionPointcut lep) {
		lepPCs.remove(lep);
	}
	
	public Set getLineExecutionPointcuts() {
		return lepPCs;
	}


}
