package garbage;

import java.util.ArrayList;

import org.eclipse.debug.core.model.IBreakpoint;




/**
 * @author Rick
 * 
 * Context associated with a triggered breakpoint
 *
 */
public class DebuggerTriggerContext implements IJavaTriggerAndTriggeredBreakpointObserver {
	/**
	 * last breakpoint reached in debugger
	 */
	private IJavaTriggerpoint lastTriggerpoint;
	
	// the list of all triggerpoints reached so far
	private ArrayList triggersReached;
	
	public DebuggerTriggerContext() {
		triggersReached = new ArrayList();
	}

	/**
	 * @param lastBreakpoint The lastBreakpoint to set.
	 */
	public void setLastTriggerpoint(IJavaTriggerpoint lastBreakpoint) {
		this.lastTriggerpoint = lastBreakpoint;
		// and update the triggers reached
		triggersReached.add(lastBreakpoint);
	}
	
	public IJavaTriggerpoint getLastTriggerpoint() {
		return lastTriggerpoint;
	}
	
	public IBreakpoint[] getBreakpointsReached() {
		return (IBreakpoint[])triggersReached.toArray();
	}
	
//	/**
//	 * @return the method breakpoints corresponding to methods in current control flow
//	 */
//	public JavaTriggerAndTriggeredMethodBreakpoint[] cFlowContext() {
//		ArrayList methodBps = new ArrayList();
//		IBreakpoint[] bps = (IBreakpoint[])triggersReached.toArray();
//		for (int i = 0; i < bps.length; i++) {
//			if (bps[i] instanceof JavaTriggerAndTriggeredMethodBreakpoint) {
//				JavaTriggerAndTriggeredMethodBreakpoint bp = (JavaTriggerAndTriggeredMethodBreakpoint)bps[i];
//				if (bp.inMethod()) {
//					methodBps.add(bp);
//				}
//			}
//		}
//		return (JavaTriggerAndTriggeredMethodBreakpoint[])methodBps.toArray();
//	}
	
//	public boolean equals(Object obj) {
//		if (obj instanceof DebuggerTriggerContext) {
//			IBreakpoint otherBP = ((DebuggerTriggerContext)obj).lastTriggerpoint;
//			if (otherBP.equals(lastTriggerpoint)) {
//				return true;
//			}
//		}
//		return false;
//	}
	
	
	/**
	 * @param ctx the other debugger trigger context
	 * @return true if this trigger context is a subset of ctx (i.e. all triggerpoints in this context are in ctx)
	 */
	public boolean subsetOf(DebuggerTriggerContext ctx) {
		for (int i = 0; i < triggersReached.size(); i++) {
			if (!ctx.triggersReached.contains(triggersReached.get(i))) {
				return false;
			}
		}
		return true;
	}
	
	public void printTriggers() {
		for (int i = 0; i < triggersReached.size(); i++) {
			System.out.println(triggersReached.get(i));
		}
	}

	public void breakpointUpdate() {
		// TODO Auto-generated method stub
		
	}
}

