package garbage;



import org.eclipse.jdt.debug.core.IJavaLineBreakpoint;

import contextualbreakpoints.pointcuts.NotPointcut;

/**
 * @author Rick
 *
 */
public interface IJavaTriggeredBreakpoint extends IJavaLineBreakpoint {
	
	
	/**
	 * @param yes true if this bp has been triggered, false if it should be untriggered
	 */
	public void setTriggered(boolean yes);
	
	
	/**
	 * @return the context this bp was created in 
	 */
	public DebuggerTriggerContext getContext();
	
	/**
	 * @param context the context to manually set this bp to be triggered by
	 */
	public void setContext(DebuggerTriggerContext context);
	
	/**
	 * @return Returns the alwaysSuspend.
	 */
	public boolean isAlwaysSuspend();

	/**
	 * @param alwaysSuspend The alwaysSuspend to set.
	 */
	public void setAlwaysSuspend(boolean alwaysSuspend);
	
	/**
	 * resets the breakpoint (e.g. sets it to not been reached etc)
	 */
	public void reset();
	
	/**
	 * @return Returns the notCondition.
	 */
	public NotPointcut getNotCondition();

	/**
	 * @param notCondition The notCondition to set.
	 */
	public void setNotCondition(NotPointcut notCondition);
}
