package garbage;

import java.util.Map;

import org.eclipse.core.resources.IResource;
import org.eclipse.debug.core.DebugException;
import org.eclipse.jdt.internal.debug.core.model.JDIDebugTarget;
import org.eclipse.jdt.internal.debug.core.model.JDIThread;



import com.sun.jdi.event.Event;

import contextualbreakpoints.breakpoints.JavaContextualLineBreakpoint;


/**
 * @author Rick
 *
 * Like a JavaTriggerPoint except it never suspends
 * 
 * JavaTriggerPoints should be deleted when all dependent triggeredbreakpoints 
 * are deleted
 * 
 */
public class JavaTriggerPoint extends JavaContextualLineBreakpoint {

	/**
	 * Constructor 
	 * 
	 * @param resource
	 * @param typeName
	 * @param lineNumber
	 * @param charStart
	 * @param charEnd
	 * @param hitCount
	 * @param add
	 * @param attributes
	 * @throws DebugException
	 */
	public JavaTriggerPoint(IResource resource, String typeName, int lineNumber, int charStart, int charEnd, int hitCount, boolean add, Map attributes) throws DebugException {
		super(resource, typeName, lineNumber, charStart, charEnd, hitCount, add,
				attributes);
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.jdt.internal.debug.core.breakpoints.JavaBreakpoint#handleBreakpointEvent(com.sun.jdi.event.Event, org.eclipse.jdt.internal.debug.core.model.JDIDebugTarget, org.eclipse.jdt.internal.debug.core.model.JDIThread)
	 */
	public boolean handleBreakpointEvent(Event event, JDIDebugTarget target, JDIThread thread) {
//		// triggerpoints update the context but do not suspend 
//		if (inTriggerContext()) {
//			// now AFTER checking the context, then update the context
//			updateDebuggerTriggerEnvironment();
//		}
		return true; // always resume
	}
	
	
	
}
